/*  DO NOT EDIT THIS FILE.

    It has been auto-edited by fixincludes from:

	"/usr/include/netinet/in.h"

    This had to be done to correct non-standard usages in the
    original, manufacturer supplied header file.  */

/*
 * BEGIN_DESC
 * 
 *  File:     in.h                       Date: 12/2/1998
 *  @(#)
 * 
 *  Purpose:
 *	Constants and structures defined by the internet system,
 *	Per RFC 790, September 1981.
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  yes
 *
 *  Shipped:  yes
 *	/usr/include/netinet/in.h
 *	/usr/conf/netinet/in.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/


#ifndef	_NETINET_IN_H
#define	_NETINET_IN_H
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 *	in.h	7.6 (Berkeley) 6/29/88 plus MULTICAST 1.1
 */


#include <sys/stdsyms.h>

#ifdef _INCLUDE_XOPEN_SOURCE_EXTENDED

#include <sys/types.h>

/*
 * Protocols
 */
#define	IPPROTO_IP		0		/* dummy for IP */
#define	IPPROTO_ICMP		1		/* control message protocol */
#define	IPPROTO_IGMP		2		/* group mgmt protocol */
#define	IPPROTO_GGP		3		/* gateway^2 (deprecated) */
#define IPPROTO_IPIP    	4       	/* IP inside IP */
#define	IPPROTO_TCP		6		/* tcp */
#define	IPPROTO_EGP		8		/* exterior gateway protocol */
#define	IPPROTO_IGP		9		/* interior gateway protocol */
#define	IPPROTO_PUP		12		/* pup */
#define	IPPROTO_UDP		17		/* user datagram protocol */
#define	IPPROTO_IDP		22		/* xns idp */
#define	IPPROTO_XTP		36		/* xtp */
#define IPPROTO_ESP             50              /* IPSec encapsulated security payload */
#define IPPROTO_AH              51              /* IPSec authentication header */
#define	IPPROTO_OSPF		89		/* open SPF routing protocol */
#define	IPPROTO_IPENCAP		94		/* former IP in IP encap */
#define IPPROTO_ENCAP           98              /* encapsulation header */
#define IPPROTO_IPPCP		108		/* IP payload compression */
#define	IPPROTO_PXP		241		/* Netipc PXP protocol */

#define	IPPROTO_RAW		255		/* raw IP packet */
#define	IPPROTO_MAX		256

#ifdef	_XOPEN_SOURCE_EXTENDED 
  
#ifndef	_IN_PORT_T
#define	_IN_PORT_T
typedef	unsigned short	in_port_t;
#endif	/* !_IN_PORT_T */

#endif /* _XOPEN_SOURCE_EXTENDED */

/*
 * Ports < IPPORT_RESERVED are reserved for
 * privileged processes (e.g. root).
 * Ports > IPPORT_USERRESERVED are reserved
 * for servers, not necessarily privileged.
 */
#define	IPPORT_RESERVED		1024
#define	IPPORT_USERRESERVED	5000

/*
 * Link numbers
 */
#define	IMPLINK_IP		155
#define	IMPLINK_LOWEXPER	156
#define	IMPLINK_HIGHEXPER	158

/*
 * Internet address (a structure for historical reasons)
 */
#ifndef	_IN_ADDR_T
#define	_IN_ADDR_T
#ifdef  __LP64__
   typedef unsigned int   in_addr_t;
#else
   typedef unsigned long  in_addr_t;
#endif  /* __LP64__ */
#endif	/* _IN_ADDR_T */

struct in_addr {
   in_addr_t  s_addr;
};

#if defined(_HPUX_SOURCE) || defined(_INCLUDE_XOPEN_SOURCE_520)
/*
 * Maximum length of IPv4 dotted decimal string (000.000.000.000) .
 */

#define INET_ADDRSTRLEN        16
#endif


/*
 * Definitions of bits in internet address integers.
 * On subnets, the decomposition of addresses to host and net parts
 * is done according to subnet mask, not the masks here.
 */
#define	IN_CLASSA(i)		(((in_addr_t)(i) & ((in_addr_t)0x80000000)) == 0)
#define	IN_CLASSA_NET		((in_addr_t)0xff000000)
#define	IN_CLASSA_NSHIFT	24
#define	IN_CLASSA_HOST		((in_addr_t)0x00ffffff)
#define	IN_CLASSA_MAX		128

#define	IN_CLASSB(i)		(((in_addr_t)(i) & ((in_addr_t)0xc0000000)) == \
 				 ((in_addr_t)0x80000000))
#define	IN_CLASSB_NET		((in_addr_t)0xffff0000)
#define	IN_CLASSB_NSHIFT	16
#define	IN_CLASSB_HOST		((in_addr_t)0x0000ffff)
#define	IN_CLASSB_MAX		65536

#define	IN_CLASSC(i)		(((in_addr_t)(i) & ((in_addr_t)0xe0000000)) == \
				 ((in_addr_t)0xc0000000))
#define	IN_CLASSC_NET		((in_addr_t)0xffffff00)
#define	IN_CLASSC_NSHIFT	8
#define	IN_CLASSC_HOST		((in_addr_t)0x000000ff)

#define	IN_CLASSD(i)		(((in_addr_t)(i) & ((in_addr_t)0xf0000000)) == \
				 ((in_addr_t)0xe0000000))

/* IN_CLASSD values are not really net and host fields */
#define	IN_CLASSD_NET		((in_addr_t)0xf0000000)
#define	IN_CLASSD_NSHIFT	28
#define	IN_CLASSD_HOST		((in_addr_t)0x0fffffff)
#define	IN_MULTICAST(i)		IN_CLASSD(i)

#define	IN_EXPERIMENTAL(i)	(((in_addr_t)(i) & ((in_addr_t)0xe0000000)) == \
				 ((in_addr_t)0xe0000000))
#define	IN_BADCLASS(i)		(((in_addr_t)(i) & ((in_addr_t)0xf0000000)) == \
				 ((in_addr_t)0xf0000000))

#define	INADDR_ANY		((in_addr_t)0x00000000)
#define	INADDR_BROADCAST	((in_addr_t)0xffffffff)	/* must be masked */
#define	INADDR_LOOPBACK		((in_addr_t)0x7f000001)

#define INADDR_LINKLOCAL        (uint32_t)0xa9fe0000    /* 169.254.0.0 */
#define INADDR_LINKLOCAL_NET    (uint32_t)0xffff0000    /* Class B net */

#define	INADDR_UNSPEC_GROUP	((in_addr_t)0xe0000000)	/* 224.0.0.0   */
#define	INADDR_ALLHOSTS_GROUP	((in_addr_t)0xe0000001)	/* 224.0.0.1   */
#define INADDR_ALLRTRS_GROUP    (uint32_t)0xe0000002    /* 224.0.0.2 */
#define	INADDR_MAX_LOCAL_GROUP 	((in_addr_t)0xe00000ff)	/* 224.0.0.255 */

#ifndef _KERNEL
#define	INADDR_NONE		((in_addr_t)0xffffffff)	/* -1 return */
#endif

#define	IN_LOOPBACKNET		127			/* official! */

#define	IN_CLASSA_BROADCAST(i)						\
	(IN_CLASSA(i) && (((i) & IN_CLASSA_HOST) == IN_CLASSA_HOST	\
	|| ((i) & IN_CLASSA_HOST) == 0))

#define	IN_CLASSB_BROADCAST(i)						\
	(IN_CLASSB(i) && (((i) & IN_CLASSB_HOST) == IN_CLASSB_HOST	\
	|| ((i) & IN_CLASSB_HOST) == 0))

#define	IN_CLASSC_BROADCAST(i)						\
	(IN_CLASSC(i) && (((i) & IN_CLASSC_HOST) == IN_CLASSC_HOST	\
	|| ((i) & IN_CLASSC_HOST) == 0))

#define IN_BROADCAST(i)							\
	((uint32_t)(i) == 0						\
	|| ((uint32_t)(i) == INADDR_BROADCAST)				\
	|| IN_CLASSA_BROADCAST(i)					\
	|| IN_CLASSB_BROADCAST(i)					\
	|| IN_CLASSC_BROADCAST(i))

#define IN_LOOPBACK(i)							\
	(((uint32_t)(i) & 0xff000000) == 0x7f000000)

#define INADDR_PRIVATE1		((uint32_t)0x0a000000)	/* 10.0.0.0 */
#define INADDR_PRIVATE2		((uint32_t)0xac1f0000)	/* 172.31.0.0 */
#define INADDR_PRIVATE3		((uint32_t)0xc0a80000)	/* 192.168.0.0 */

#define IN_PRIVATE(i)							\
	(((uint32_t)(i) & 0xff000000) == INADDR_PRIVATE1		\
	|| ((uint32_t)(i) & 0xffff0000) == INADDR_PRIVATE2		\
	|| ((uint32_t)(i) & 0xffff0000) == INADDR_PRIVATE3)

/*
 * Socket address, internet style.
 */
#ifdef _XOPEN_SOURCE_EXTENDED

#ifndef	_SA_FAMILY_T
#define	_SA_FAMILY_T
typedef	unsigned short	sa_family_t;
#endif /* !_SA_FAMILY_T */

struct sockaddr_in {
	sa_family_t 	sin_family;
	in_port_t	sin_port;
	struct	in_addr sin_addr;
	unsigned char	sin_zero[8];
};
#else
struct sockaddr_in {
	short	sin_family;
	u_short	sin_port;
	struct	in_addr sin_addr;
	char	sin_zero[8];
};
#endif	/* _XOPEN_SOURCE_EXTENDED */

#if 1
/*
 * Macros for number representation conversion.
 */
#ifndef ntohl
#define	ntohl(x)	(x)
#define	ntohs(x)	(x)
#define	htonl(x)	(x)
#define	htons(x)	(x)
#endif
#endif	/* ! _XOPEN_SOURCE_EXTENDED */

/*
 * Options for use with [gs]etsockopt at the IP level.
 */
#define	IP_OPTIONS		1	/* set/get IP per-packet options   */
#define	IP_MULTICAST_IF		2	/* set/get IP multicast interface  */
#define	IP_MULTICAST_TTL	3	/* set/get IP multicast timetolive */
#define	IP_MULTICAST_LOOP	4	/* set/get IP multicast loopback   */
#define	IP_ADD_MEMBERSHIP	5	/* add  an IP group membership     */
#define	IP_DROP_MEMBERSHIP	6	/* drop an IP group membership     */
#define IP_TOS                  8       /* IP type of service, precedence  */
#define	IP_TTL			16      /* set/get socket's ttl */

#define	IP_HDRINCL	0x1002  /* int; header is included with data (raw) */
#define	IP_RECVOPTS	0x1005  /* bool; receive all IP options w/datagram */
#define	IP_RECVRETOPTS	0x1006  /* bool; receive IP options for response */
#define	IP_RECVDSTADDR	0x1007  /* bool/int; receive IP dst addr w/datagram */
#define	IP_RETOPTS	0x1008  /* ip_opts; set/get IP per-packet options */
#define	IP_BROADCAST_IFNAME	0x1015  /* Set interface name for broadcasts */
#define	IP_RECVIFADDR		0x1016  /* bool/int; recv IP addr of dest IF */
#define	IP_LINK_STATUS		0x1017	/* bool; receive link status messages */
#define IP_BROADCAST_IF         0x1018  /* Set interface addr for broadcasts */
#define IP_RECVLINKSRC          0x1019  /* bool; recv source link-layer addr */
#define IP_RECVTTL              0x1020  /* bool; recv TTL of inbound packet */
#define IP_TUNNEL_NOTIFIES      0x1021  /* i32; be notified of tunnel events */

#define	IP_DEFAULT_MULTICAST_TTL   1	/* normally limit m'casts to 1 hop  */
#define	IP_DEFAULT_MULTICAST_LOOP  1	/* normally hear sends if a member  */
#define	IP_MAX_MEMBERSHIPS         20	/* per socket; must fit in one mblk */
					/* Change mbuf to mblk JAGad94239 */

#ifndef _XOPEN_SOURCE_EXTENDED
/*
 * Argument structure for IP_ADD_MEMBERSHIP and IP_DROP_MEMBERSHIP.
 */
struct ip_mreq {
	struct in_addr	imr_multiaddr;	/* IP multicast address of group */
	struct in_addr	imr_interface;	/* local IP address of interface */
};
#endif /* ! _XOPEN_SOURCE_EXTENDED */

#ifdef _KERNEL

extern  struct domain inetdomain;
extern  struct protosw inetsw[];

#endif  /* _KERNEL */

#include <netinet/in6.h>

#endif /* _INCLUDE_XOPEN_SOURCE_EXTENDED */

#endif	/* _NETINET_IN_H */
